//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Color.h"
#include "Colors.h"
#include "ColorSelecter.h"
#include "math.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TColorCustamizeDialog *ColorCustamizeDialog;
//---------------------------------------------------------------------
__fastcall TColorCustamizeDialog::TColorCustamizeDialog(TComponent* AOwner)
	: TForm(AOwner)
{
}


void __fastcall TColorCustamizeDialog::FormDestroy(TObject *Sender)
{
        delete buf;

}
//---------------------------------------------------------------------------

void __fastcall TColorCustamizeDialog::CallDrawpalette(TObject *Sender)
{
        pb->Canvas->Draw(0,0,buf);

}
//---------------------------------------------------------------------------
void __fastcall TColorCustamizeDialog::Drawpalette(void)
{
        int i,c;

        TRect Rectp;
        Rectp = Rect(0,0,185,128);

        buf->Canvas->Brush->Color = BGColor_;
        buf->Canvas->FillRect(Rectp);

        h1 = 255-TBH1->Position;
        h2 = (255-TBH2->Position-h1+256) & 0xff;
        s1 = 255-TBS1->Position;
        s2 = 255-TBS2->Position-s1;
        v1 = 255-TBV1->Position;
        v2 = 255-TBV2->Position-v1;

        unsigned char r,g,b;
        for(i=0; i<256; i++){
                HSVtoRGB((unsigned char)((h1+random(h2)) & 0xff),
                         (unsigned char)(s1+random(s2)),
                         (unsigned char)(v1+random(v2)),
                         r,g,b);
                c = r;
                c |= g<<8;
                c |= b<<16;
                buf->Canvas->Brush->Color = (TColor)c;
                buf->Canvas->Pen->Color = (TColor)c;

                buf->Canvas->Rectangle(rectpos[i]);

        }

        pb->Canvas->Draw(0,0,buf);

}

//---------------------------------------------------------------------------
void __fastcall TColorCustamizeDialog::RectposSet(TObject *Sender)
{
        int i,j;
        double x,y,z=0;

        for(i=1; i<=256; i++){
                z += 0.84/sqrt(float(i));
                x = -i*cos(z)/4.0;
                y = i*sin(z)/4.0;
                j = (i+200)/100;
                rectpos[i-1] = Rect(int(x+91),int(y+63),int(x+91+j),int(y+63+j));
        }

        buf = new Graphics::TBitmap();
        buf->PixelFormat = pf32bit;
        buf->Height = 128;
        buf->Width = 185;

        BGColor_ = eTeForm->Tan->BGColor;
        switch(BGColor_){
                case clBlack : RadioGroup1->ItemIndex = 0; break;
                case clWhite : RadioGroup1->ItemIndex = 1; break;
                case clAppWorkSpace : RadioGroup1->ItemIndex = 2; break;
                default : RadioGroup1->ItemIndex = -1;
        }

        TBH1->Position = 255-eTeForm->ho;
        TBH2->Position = 255-eTeForm->hr-eTeForm->ho;
        TBS1->Position = 255-eTeForm->so;
        TBS2->Position = 255-eTeForm->sr-eTeForm->so;
        TBV1->Position = 255-eTeForm->vo;
        TBV2->Position = 255-eTeForm->vr-eTeForm->vo;

        Drawpalette();

}
//---------------------------------------------------------------------------

void __fastcall TColorCustamizeDialog::RadioGroup1Click(TObject *Sender)
{
        switch(RadioGroup1->ItemIndex) {
                case 0 : BGColor_ = clBlack; break;
                case 1 : BGColor_ = clWhite; break;
                case 2 : BGColor_ = clAppWorkSpace; break;
                case 3 :
                         ColorSelecterForm = new TColorSelecterForm(this);
                         ColorSelecterForm->ColorSelect((int)BGColor_);
                         ColorSelecterForm->SBX->Position = eTeForm->sbx;
                         ColorSelecterForm->SBY->Position = eTeForm->sby;
                         ColorSelecterForm->SBZ->Position = eTeForm->sbz;
                         ColorSelecterForm->SBChange(this);
                         if(ColorSelecterForm->ShowModal() == mrOk)
                                BGColor_ = (TColor)ColorSelecterForm->CurrentColor;
                         eTeForm->sbx = ColorSelecterForm->SBX->Position;
                         eTeForm->sby = ColorSelecterForm->SBY->Position;
                         eTeForm->sbz = ColorSelecterForm->SBZ->Position;
                         delete ColorSelecterForm;
                         RadioGroup1->ItemIndex = -1;

        }
        Drawpalette();
}

//---------------------------------------------------------------------------

void __fastcall TColorCustamizeDialog::pbClick(TObject *Sender)
{
        RadioGroup1->ItemIndex = 3;
}
//---------------------------------------------------------------------------

void __fastcall TColorCustamizeDialog::TBH1Change(TObject *Sender)
{
        if( abs(TBH1->Position - TBH2->Position)<8 ) {
                TBH1->Position = TBH2->Position;
        }
        Drawpalette();
}
void __fastcall TColorCustamizeDialog::TBH2Change(TObject *Sender)
{
        if( abs(TBH1->Position - TBH2->Position)<8 ) {
                TBH2->Position = TBH1->Position;
        }
        Drawpalette();
}
//---------------------------------------------------------------------------

void __fastcall TColorCustamizeDialog::TBS1Change(TObject *Sender)
{
        if( TBS1->Position < TBS2->Position ) {
                TBS2->Position = TBS1->Position;
        }
        Drawpalette();
}
void __fastcall TColorCustamizeDialog::TBS2Change(TObject *Sender)
{
        if( TBS1->Position < TBS2->Position ) {
                TBS1->Position = TBS2->Position;
        }
        Drawpalette();
}
//---------------------------------------------------------------------------

void __fastcall TColorCustamizeDialog::TBV1Change(TObject *Sender)
{
        if( TBV1->Position < TBV2->Position ) {
                TBV2->Position = TBV1->Position;
        }
        Drawpalette();
}
void __fastcall TColorCustamizeDialog::TBV2Change(TObject *Sender)
{
        if( TBV1->Position < TBV2->Position ) {
                TBV1->Position = TBV2->Position;
        }
        Drawpalette();
}
//---------------------------------------------------------------------------

//ݒ̓o^
void __fastcall TColorCustamizeDialog::Button1Click(TObject *Sender)
{

        eTeForm->bgcolor_ = BGColor_;
        eTeForm->ho_ = h1;
        eTeForm->hr_ = h2;
        eTeForm->so_ = s1;
        eTeForm->sr_ = s2;
        eTeForm->vo_ = v1;
        eTeForm->vr_ = v2;

}

//ݒ̌Ăяo
void __fastcall TColorCustamizeDialog::Button2Click(TObject *Sender)
{

        RadioGroup1->ItemIndex = -1;
        BGColor_ = eTeForm->bgcolor_;
        TBH1->Position = 255-eTeForm->ho_;
        TBH2->Position = 255-((eTeForm->hr_ + eTeForm->ho_) & 0xff);
        TBS1->Position = 255-eTeForm->so_;
        TBS2->Position = 255-(eTeForm->sr_ + eTeForm->so_);
        TBV1->Position = 255-eTeForm->vo_;
        TBV2->Position = 255-(eTeForm->vr_ + eTeForm->vo_);
        Drawpalette();

}
//---------------------------------------------------------------------------

