//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "ColorSelecter.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TColorSelecterForm *ColorSelecterForm;
//---------------------------------------------------------------------------
__fastcall TColorSelecterForm::TColorSelecterForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TColorSelecterForm::FormDestroy(TObject *Sender)
{

        free(zidx);
        free(x);
        free(y);
        free(z);
        free(l);

        delete buf;
        delete Colors;

}
//---------------------------------------------------------------------------
void __fastcall TColorSelecterForm::FormCreate(TObject *Sender)
{

        //摜obt@̏
        buf = new Graphics::TBitmap;
        buf->PixelFormat = pf24bit;
        buf->Width = 256;
        buf->Height = 256;

        //Ff[^̓ǂݍ
        Colors = new TColors();
        x    = (int *)malloc(Colors->Total * sizeof(int));
        y    = (int *)malloc(Colors->Total * sizeof(int));
        z    = (int *)malloc(Colors->Total * sizeof(int));
        l    = (int *)malloc(Colors->Total * sizeof(int));
        zidx = (int *)malloc(Colors->Total * sizeof(int));

        //math.hge[u
        //------------------------------------
        for(int i=0; i<256; i++){
                ctbl[i] = (int)(cos(2.*M_PI*i/256.)*512.5);
        }
        //------------------------------------

        ColorSelect(0);

}
//---------------------------------------------------------------------------
void __fastcall TColorSelecterForm::PBMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{

        ColorSelect(buf->Canvas->Pixels[X][Y]);
        RePict();

}

void TColorSelecterForm::ColorSelect(int c)
{
        AnsiString t;
        int i,imax;
        bool selected;
        unsigned char r,g,b,h,s,v;

        r = c & 0xff;
        g = (c>>8) & 0xff;
        b = (c>>16) & 0xff;

        if(c == 0x808080) return;

        Shape->Brush->Color =
        (TColor)(((int)b<<16) |
                 ((int)g<<8)  |
                  (int)r );
        RGBtoHSV(r,g,b, h,s,v);
        t = "R:";
        t += IntToStr((int)r)+" G:";
        t += IntToStr((int)g)+" B:";
        t += IntToStr((int)b)+" (H:";
        t += IntToStr((int)h)+" S:";
        t += IntToStr((int)s)+" V:";
        t += IntToStr((int)v)+")\n";
        imax = Colors->Total;
        selected = false;
        for(i=0; i<imax; i++){
                if((TColor)c == (TColor)
                        (((int)Colors->b[i]<<16) |
                         ((int)Colors->g[i]<<8) |
                          (int)Colors->r[i] )) {
                        t += Colors->Name->Strings[i]+"\n";
                        CurrentColorIndex = i;
                        selected = true;
                }
        }
        if(! selected) return;
        Label->Caption = t;
        i = CurrentColorIndex;
        CurrentColor =
                (((int)Colors->b[i]<<16) |
                 ((int)Colors->g[i]<<8)  |
                  (int)Colors->r[i] );

}
//---------------------------------------------------------------------------

//]ϊ
TPoint TColorSelecterForm::roll(int u,int v,int w)
{
        int s,c,x,y;

        if(w<0) {
                w=256-(-w%256);
        } else {
                w=w%256;
        }
        s=ctbl[(w+192)%256];
        c=ctbl[w];
        x=(u*c-v*s)/512;
        y=(u*s+v*c)/512;

	return Point(x,y);
}

void __fastcall TColorSelecterForm::SBChange(TObject *Sender)
{

        int theta = SBX->Position*2;
        int phi   = SBY->Position*2;

        int i,imax,j,m;
        TPoint p;
        imax = Colors->Total;

        for(i=0; i<imax; i++){
                zidx[i] = i;

                j = theta + (int)Colors->h[i];
                p = roll(0,Colors->s[i]*Colors->v[i]/255,j);
                m = p.y;
                p = roll((Colors->v[i]*2-255)
                        -(Colors->s[i]*Colors->v[i]/255)
                                *(1600+ctbl[(Colors->h[i]+80)&255])/1600
                        ,p.x,phi);
                j = 600+p.y;
                x[i] = 128+m*j*SBZ->Position/28000;
                y[i] = 128-p.x*j*SBZ->Position/28000;
                z[i] = j;
                l[i] = j/80;

        }

        for(i=0; i<imax; i++){
                for(j=0; j<i; j++){
                        if(z[i-j] < z[i-j-1]){
                                m = z[i-j];
                                z[i-j] = z[i-j-1];
                                z[i-j-1] = m;
                                m = zidx[i-j];
                                zidx[i-j] = zidx[i-j-1];
                                zidx[i-j-1] = m;
                        } else break;
                }
        }

        RePict();
}

void TColorSelecterForm::RePict(void)
{
        int i,imax,j,u,v;
        imax = Colors->Total;

        buf->Canvas->Brush->Color = clGray;
        buf->Canvas->FillRect( Rect(0,0,256,256) );

        for(j=0; j<imax; j++){
                i = zidx[j];
                buf->Canvas->Brush->Color =
                (TColor)(((int)Colors->b[i]<<16) |
                         ((int)Colors->g[i]<<8)  |
                          (int)Colors->r[i] );

                buf->Canvas->FillRect( Rect(x[i],y[i],x[i]+l[i],y[i]+l[i]) );
        }

        FormPaint(this);                

}
//---------------------------------------------------------------------------

void __fastcall TColorSelecterForm::FormPaint(TObject *Sender)
{
        PB->Canvas->Draw( 0,0,buf );
        int u,v,r,s;
        int i = CurrentColorIndex;
                u = x[i]+l[i]/2;
                v = y[i]+l[i]/2;
                if(u<128) r = -1; else r = 1;
                if(v>128) s = -1; else s = 1;
                PB->Canvas->Pen->Color = clWhite;
                PB->Canvas->MoveTo(u,v);
                PB->Canvas->LineTo(u+2*r,v-8*s);
                PB->Canvas->LineTo(u+2*r,v-2*s);
                PB->Canvas->LineTo(u+8*r,v-2*s);
                PB->Canvas->LineTo(u,v);
                PB->Canvas->LineTo(u+10*r,v-10*s);
                PB->Canvas->LineTo(u,v);
}
//---------------------------------------------------------------------------

