#include <vcl.h>
#pragma hdrstop

#include "math.h"
#include "Tangram.h"
#include "Colors.h"

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yx[VbNz

//RXgN^
Tangram::Tangram(void)
{
        int i;

        //math.hge[u
        //------------------------------------
        for(i=0; i<720; i++){
                ctbl[i] = (int)(cos(2.*M_PI*i/720.)*512.5);
        }
        //------------------------------------

        ZoomPercentage = 100;

        mkGammaTable(1.0);

        strPltes = new TStringList();
        strPcses = new TStringList();

        SetDefault();
        NewFile();
        CSet(clBlack, 255,255,255, 0,0,0);

}

//K}e[ǔvZ
void Tangram::mkGammaTable(double g)
{
        double x,y;
        int i;

        gamma = g;
        if(gamma < 1.0) gamma = 2.2;
        if(gamma > 3.0) gamma = 2.2;

        if(gamma == 1.0){
                for(i=0; i<256; i++) gtbl[i] = i;
                return;
        }

        i = 1;
        for(x=0; x<1.; x += .0005){
                y = pow(x,gamma) * 256.;
                if((int)y == i){
                        i++;
                        gtbl[i] = (int)(x * 256.);
                }
        }
        gtbl[0] = 0;
        gtbl[511] = 255;

}

//fXgN^
Tangram::~Tangram(void)
{
        delete strPcses;
        delete strPltes;

}


//fBtHg̃^Os[Xݒ
void Tangram::SetDefault(void)
{
        strPltes->Clear();
        strPltes->Add("tan");
        strPltes->Add("7");
        strPltes->Add("3,28,28,0,0,0,80,80,0");
        strPltes->Add("3,40,14,0,0,40,40,80,0");
        strPltes->Add("4,40,40,40,0,0,40,40,80,80,40");
        strPltes->Add("3,14,40,0,0,0,80,40,40");
        strPltes->Add("4,20,60,0,40,0,120,40,80,40,0");
        strPltes->Add("3,56,80,0,80,80,160,80,0");
        strPltes->Add("3,80,56,80,0,0,80,160,80");
        strPltes->Add("28,28,0,1,120,14,0,1,80,40,0,1,54,80,0,1,20,100,0,1,132,80,0,1,80,132,0,1");
        strPltes->Add("^O");
        strPltes->Add("90");
        strPltesExpand(strPltes);

}


//*.pltǂݍstrPltesPltPcsOr쐬
void Tangram::strPltesExpand(TStringList* strPltes)
{
        int i,j;

        Plt.Name = strPltes->Strings[0];
        Plt.Plates = StrToInt(strPltes->Strings[1]);

        for(i=0; i<Plt.Plates; i++){
                s = strPltes->Strings[2+i];
                sTod();
                Plt.Edges[i] = d[0];
                Plt.centerX[i] = d[1];
                Plt.centerY[i] = d[2];
                for(j=0; j<d[0] ;j++){
                        Plt.X[i][j] = d[3+j*2];
                        Plt.Y[i][j] = d[4+j*2];
                }
                Plt.X[i][d[0]] = d[3+d[0]*2];
                Plt.Y[i][d[0]] = d[4+d[0]*2];
        }
        s = strPltes->Strings[2+Plt.Plates];
        sTod();
        for(i=0; i<Plt.Plates; i++){
                PcsOr.X[i] = d[i*4]+176;
                PcsOr.Y[i] = d[1+i*4]+176;
                PcsOr.dDeg[i] = d[2+i*4];
                PcsOr.Flip[i] = (double)d[3+i*4];
        }

        Plt.Caption = strPltes->Strings[3+Plt.Plates];
        Plt.unitDeg = StrToInt(strPltes->Strings[4+Plt.Plates]);

        //D揇ʂ̏
        for(i=0; i<Plt.Plates; i++) prior[(Plt.Plates-1)-i] = i;

}


//s  Pcs
void Tangram::sToPcs(void)
{
        int i;

        sTod();
        for(i=0; i<Plt.Plates; i++){
                Pcs.X[i] = d[i*4];
                Pcs.Y[i] = d[1+i*4];
                Pcs.dDeg[i] = d[2+i*4];
                Pcs.Flip[i] = (double)d[3+i*4];
        }

}


//s  d
//iR}؂蕶񂩂琔loj
void Tangram::sTod(void)
{
        AnsiString t;
        int i=-1,j=0,k=0;
        char cd[4096],cs[32];

        StrPCopy(cd,s);
        do{
                i++;
                if((cd[i] != 44)&&(cd[i] != 0)){
                        cs[j] = cd[i];
                        j++;
                } else {
                        cs[j] = 0;
                        j = 0;
                        t = cs;
                        d[k] = StrToInt(t);
                        k++;
                }
        }while(cd[i] != 0);
}


//Pcs  s
void Tangram::PcsTos(void)
{
        int i;

        s = "";
        for(i=0; i<Plt.Plates; i++){
               s += IntToStr(Pcs.X[i])+",";
               s += IntToStr(Pcs.Y[i])+",";
               s += IntToStr(Pcs.dDeg[i])+",";
               s += IntToStr((int)Pcs.Flip[i]);
               if(i != Plt.Plates-1) s+=",";
        }

}








//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yJgz

//Pcs̏
void Tangram::NewPcs(void)
{
        int i;

        PcsOr.Caption = "̖ݒ";

        //PcsPcsOr(+Ԃ)
        Pcs = PcsOr;
        for(i=0; i<Plt.Plates ;i++){
                Pcs.X[i] += (PcsOr.X[i]-256)/4-8+random(16);
                Pcs.Y[i] += (PcsOr.Y[i]-256)/4-8+random(16);
        }

        PltSleep();
        RefleshBank();

        //ItȌ
        for(i=0; i<Plt.Plates; i++) active[i] = true;

}


//XgPcsI
void Tangram::PcsSelect(int index)
{
        Pcs.Caption = strPcses->Strings[1+index*2];
        s = strPcses->Strings[2+index*2];
        sToPcs();

        PltSleep();
        RefleshBank();
}


//Pcs
void Tangram::PushPcs(TPcs &srcPcs)
{
        Pcs = srcPcs;

        PltSleep();
        RefleshBank();
}


//Pcŝ܂܏o
void Tangram::PopPcs(TPcs &dstPcs)
{
        dstPcs = Pcs;
}


//Pcs.Captionݒ肷
void Tangram::PushPcsCaption(int index, AnsiString PcsCaption)
{
        if(index<0){
                Pcs.Caption = PcsCaption;
        } else {
                strPcses->Strings[1+index*2] = PcsCaption;
        }
}


//Pcs.Caption𓾂
AnsiString Tangram::PopPcsCaption(int index)
{
        if(index<0){
                return Pcs.Caption;
        } else {
                return strPcses->Strings[1+index*2];
        }
}


//s[X̎擾
void Tangram::PltSelect(TPoint pos, Graphics::TBitmap* buf, bool realselect)
{

        int n,i,j,x,y;
        TColor bgcolor;
        TColor pltcolor[maxplates];
        Byte a,b;
        Byte *ptr;

        //}EXJ[\̈ʒuɂs[X͋ZŒT
        PltSleep();
        bgcolor = BGColor;
        BGColor = clWhite;
        for(i=0 ; i<maxplates; i++){
                pltcolor[i] = PltColor[i];
                PltColor[i] = (TColor)(i);
        }
        GetBmp(-1,1.,buf,false);
        BGColor = bgcolor;
        for(i=0 ; i<maxplates; i++) PltColor[i] = pltcolor[i];

        ptr = (Byte *)buf->ScanLine[pos.y];
        n = ptr[pos.x*3+2];
        if(n >= 0 && n < 32) PltActive = (int)n;

        if(realselect){
                //ItȌ
                for(i=0; i<Plt.Plates; i++) active[i] = true;
                if(PltActive == plNone){
                        PltActive = plAll;
                } else {
                        //pltActivẽs[XŗD
                        x = PltActive;
                        for(i=Plt.Plates-1; i>=0; i--){
                                y = prior[i];
                                prior[i] = x;
                                if(y == PltActive) break;
                                x = y;
                        }
                }
        } else {
                //pltActivẽs[X
                if(PltActive != plNone){
                        x = PltActive;
                        for(i=0; i<Plt.Plates; i++){
                                y = prior[i];
                                prior[i] = x;
                                if(y == PltActive) break;
                                x = y;
                        }
                        PltSleep();
                }
        }

}

//`I
void Tangram::PltSelectRect(TRect rect)
{
        int i,j,x,y;
        int n = 0;
        PltActive = plNone;

        for(i=0; i<Plt.Plates; i++){
                PopBank(i,1.);
                for(j=0; j<Plt.Edges[i]; j++){
                        if(WithinRect(rect,Point(PltPoint[j].x,PltPoint[j].y))){
                                PltActive = i;
                                break;
                        }
                }
                if(i == PltActive){
                        active[i] = true;
                        n ++;

                        //pltActivẽs[XŗD
                        x = PltActive;
                        for(j=Plt.Plates-1; j>=0; j--){
                                y = prior[j];
                                prior[j] = x;
                                if(y == PltActive) break;
                                x = y;
                        }
                } else  active[i] = false;
        }
        if(n > 1) PltActive = plAll;

}

//`ǂ̃`FbN
bool Tangram::WithinRect(TRect rect, TPoint point)
{
        int i;
        if(rect.Top > rect.Bottom){
                i = rect.Bottom;
                rect.Bottom = rect.Top;
                rect.Top = i;
        }
        if(rect.Left > rect.Right){
                i = rect.Right;
                rect.Right = rect.Left;
                rect.Left = i;
        }
        if((point.x<rect.Left) || (point.x>rect.Right)) return false;
        if((point.y<rect.Top) || (point.y>rect.Bottom)) return false;
        return true;

}

//s[X̊J
void Tangram::PltSleep(void)
{
        PltActive = plNone;
        AllRotFlag = false;

}


//s[Ẍړ
void Tangram::PltMove(int dx, int dy)
{
        int i;

        for( i=0; i<Plt.Plates; i++){
                if((PltActive == plAll && active[i]) || (i == PltActive)){
                        Pcs.X[i] += dx;
                        Pcs.Y[i] += dy;
                        PushBank(i);
                }
        }

}


//s[XQ]
void Tangram::AllRotRefresh(void)
{

        AllRotFlag = false;

}

//s[X̉]
void Tangram::PltRotate(int ddDeg)
{
        int i;
        TPoint xy;

        //Ps[X̉]
        if(PltActive != plAll){
                Pcs.dDeg[PltActive] = Cutw(Pcs.dDeg[PltActive] + ddDeg);
                PushBank(PltActive);

        //Ŝ̉]
        } else {
                if(! AllRotFlag){
                        Pcs_ = Pcs;
                        AllRotdDeg = 0;
                        AllRotFlag = true;
                        AllRotAxis = GetAllRotAxis();
                }
                AllRotdDeg = Cutw(AllRotdDeg+ddDeg);
                for( i=0; i<Plt.Plates; i++ ){
                        if(active[i]){
                                xy = roll(Pcs_.X[i]-AllRotAxis.x,Pcs_.Y[i]-AllRotAxis.y,AllRotdDeg);
                                Pcs.X[i] = AllRotAxis.x+xy.x;
                                Pcs.Y[i] = AllRotAxis.y+xy.y;
                                Pcs.dDeg[i] = Cutw(Pcs_.dDeg[i]+AllRotdDeg);
                        }
                }
                RefleshBank();

        }

}

//AWXg]
void Tangram::PltRotAdjust()
{
        int i;
        TPoint xy;

        //Ps[X̉]AWXg
        if(PltActive != plAll){
                i = PltActive;
                Pcs.dDeg[i] =
                  (((Pcs.dDeg[i]+Plt.unitDeg/2)/Plt.unitDeg)*Plt.unitDeg)%720;
                PushBank(PltActive);

        //Ŝ̉]AWXg
        } else {
                if(! AllRotFlag){
                        Pcs_ = Pcs;
                        AllRotdDeg = 0;
                        AllRotFlag = true;
                        AllRotAxis = GetAllRotAxis();
                }
                for( i=0; i<Plt.Plates; i++ ) if(active[prior[i]]) break;
                i = prior[i];
                AllRotdDeg +=
                  (((Pcs.dDeg[i]+Plt.unitDeg/2)/Plt.unitDeg)*Plt.unitDeg)%720
                  -Pcs.dDeg[i];
                AllRotdDeg = Cutw(AllRotdDeg);

                for( i=0; i<Plt.Plates; i++ ){
                        if(active[i]){
                                xy = roll(Pcs_.X[i]-AllRotAxis.x,Pcs_.Y[i]-AllRotAxis.y,AllRotdDeg);
                                Pcs.X[i] = AllRotAxis.x+xy.x;
                                Pcs.Y[i] = AllRotAxis.y+xy.y;
                                Pcs.dDeg[i] = Cutw(Pcs_.dDeg[i]+AllRotdDeg);
                        }
                }
                RefleshBank();

        }

}

int Tangram::Cutw(int w)
{
        //Sp720ɐ܂
        if(w<0) {
                return 720-(-w%720);
        } else {
                return w%720;
        }
}

//s[X̔]
void Tangram::PltFlip(void)
{

        int i;
        if(PltActive == plNone) return;

        //Ps[X̔]
        if(PltActive != plAll){
                Pcs.Flip[PltActive] = -Pcs.Flip[PltActive];
                Pcs.dDeg[PltActive] = Cutw(-Pcs.dDeg[PltActive]);
                return;
        }

        //s[X̔]
        TPoint FlipAxis = GetAllRotAxis();
        for(i=0; i<Plt.Plates; i++){
                if(active[i]){
                        Pcs.Flip[i] = -Pcs.Flip[i];
                        Pcs.dDeg[i] = Cutw(-Pcs.dDeg[i]);
                        Pcs.X[i] = FlipAxis.x * 2 - Pcs.X[i];
                }
        }

}

//s[XQ̒S߂
TPoint Tangram::GetAllRotAxis(void)
{

        int i,x,y;
        int n = 0;
        x = 0;
        y = 0;
        for(i=0; i<Plt.Plates; i++){
                if(active[i]){
                        n ++;
                        x += Pcs.X[i];
                        y += Pcs.Y[i];
                }
        }
        if(n == 0) n++;
        return Point(x/n,y/n);

}

//PltPointBank̃tbV
void Tangram::RefleshBank(void)
{
        int i;
        for(i=0; i<Plt.Plates; i++){
                CalcPoint(i);
                PushBank(i);
        }
}


//pltnum̃s[XPltPointPltPointBank
void Tangram::PushBank(int pltnum)
{
        int i;
        CalcPoint(pltnum);
        for(i=0; i<Plt.Edges[pltnum]; i++){
                PltPointBank[pltnum][i] = PltPoint[i];
        }
}


//PltPointBankpltnum̃s[XPltPoint
void Tangram::PopBank(int pltnum, double ratio)
{
        int i;
        for(i=0; i<Plt.Edges[pltnum]; i++){
                PltPoint[i] = Point(
                        (int)((double)PltPointBank[pltnum][i].x*ratio) ,
                        (int)((double)PltPointBank[pltnum][i].y*ratio) );
        }
}


//pltnum̃s[X̕`WvZAPltPointɊi[
void Tangram::CalcPoint(int pltnum)
{
        int i,j;
        int cx,cy,x,y,r,f;
        double fl;
        TPoint Center,EPoint;
        i=pltnum;

        cx=Pcs.X[i];
        cy=Pcs.Y[i];
        r=Pcs.dDeg[i];
        fl=Pcs.Flip[i];
        x=(int)((double)Plt.centerX[i]*fl);
        y=Plt.centerY[i];
        Center = roll(x,y,r);

        for(j=0; j<Plt.Edges[i]; j++){
                EPoint = roll((int)((double)Plt.X[i][j]*fl),Plt.Y[i][j],r);
                PltPoint[j] = Point(
                        cx+EPoint.x-Center.x, cy+EPoint.y-Center.y);
        }


        //STӂ̒
         if(r%Plt.unitDeg == 0){
          r=Plt.Edges[i];
          for(j=0; j<r; j++){
           f = (j+1) % r;
           x = PltPoint[f].x-PltPoint[j].x;
           y = PltPoint[f].y-PltPoint[j].y;
           if((abs(x)>20)&&(abs(abs(x)-abs(y))<2)){
            cx = PltPoint[f].x-PltPoint[(f+1)%r].x;
            cy = PltPoint[f].y-PltPoint[(f+1)%r].y;
            if(cx*cy == 0){
             if(cx == 0){
              PltPoint[f].y = PltPoint[j].y + abs(x)*(y/abs(y));
             }
             if(cy == 0){
              PltPoint[f].x = PltPoint[j].x + abs(y)*(x/abs(x));
             }
            } else {
             cx = PltPoint[(j+r-1)%r].x-PltPoint[j].x;
             cy = PltPoint[(j+r-1)%r].y-PltPoint[j].y;
             if(cx == 0){
              PltPoint[j].y = PltPoint[f].y - abs(x)*(y/abs(y));
             }
             if(cy == 0){
              PltPoint[j].x = PltPoint[f].x - abs(y)*(x/abs(x));
             }
            }

           }
          }
         }
        //

}


//]ϊ
TPoint Tangram::roll(int u,int v,int w)
{
        int s,c,x,y;

        if(w<0) {
                w=720-(-w%720);
        } else {
                w=w%720;
        }
        s=ctbl[(w+540)%720];
        c=ctbl[w];
        x=(u*c-v*s)/512;
        y=(u*s+v*c)/512;

	return Point(x,y);
}








//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yXgz

//ǉ
void Tangram::ListAdd(int index)
{
        PcsTos();
        if(index<0){
                strPcses->Add(Pcs.Caption);
                strPcses->Add(s);
        } else {
                strPcses->Insert(1+index*2,Pcs.Caption);
                strPcses->Insert(2+index*2,s);
        }

        PcsTotal++;
        ModifiedFlag = true;

}


//폜
void Tangram::ListDelete(int index)
{
        strPcses->Delete(1+index*2);
        strPcses->Delete(1+index*2);

        PcsTotal--;
        ModifiedFlag = true;

}


//
void Tangram::ListExchange(int index1, int index2 )
{
        strPcses->Exchange(1+index1*2,1+index2*2);
        strPcses->Exchange(2+index1*2,2+index2*2);

        ModifiedFlag = true;

}








//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yt@Cz

//VKt@C
void Tangram::NewFile(void)
{
        strPcses->Clear();
        strPcses->Add(Plt.Name);

        PcsTotal = 0;
        Filename = "Vt@C";
        ModifiedFlag = false;

        NewPcs();

}


//*.pltt@C̓ǂݍ
void Tangram::PltLoad(AnsiString pltname)
{
        PltLoadBody(pltname);
        NewFile();
}
void Tangram::PltLoadBody(AnsiString pltname)
{
        ErrorFlag = false;
        AnsiString pltname_ = pltname;
        pltname += ".plt";

        if(FileExists(pltname) == false){
                pltname = ExtractFilePath(Application->ExeName)
                                + "pltes\\" + pltname;
                if(FileExists(pltname) == false){

                        pltNotFound();

                        SetDefault();
                        NewFile();
                        return;
                }
        }

        strPltes->Clear();
        strPltes->LoadFromFile(pltname);

        //o[W̃`FbN
        if(strPltes->Strings[0] == pltname_){
                strPltes->Insert(0,"2.13");

                if(MessageDlg(
                        "pltt@CeTe2.13OɎgĂ̂̂悤łB\n\nt@CVo[W̌`ɏ܂H",
                        mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)
                         == mrYes){
                        strPltes->SaveToFile(pltname);
                }
        } else {
                if(strPltes->Strings[0] != "2.13"){
                        MessageDlg(
                                "pltt@CΉ̃o[Ŵ̂łB",
                                mtInformation,TMsgDlgButtons() << mbOK, 0);

                        ErrorFlag = true;

                        SetDefault();
                        NewFile();
                        return;
                }
        }
        //

        strPltes->Delete(0);
        strPltesExpand(strPltes);

}


//*.etet@C̓ǂݍ
void Tangram::eTeLoad(AnsiString etename)
{
        PltChangedFlag = false;
        ErrorFlag = false;

        if(FileExists(etename) == false){

                eteNotFound();

                return;
        }

        strPcses->Clear();

        Filename = etename;
        strPcses->LoadFromFile(etename);

        //o[W̃`FbN
        if(strPcses->Strings[0] != "2.13"){
                if((FileExists(ExtractFilePath(etename)
                        + strPcses->Strings[0] + ".plt")) ||
                   (FileExists(ExtractFilePath(Application->ExeName)
                        + "pltes\\" + strPcses->Strings[0] + ".plt")) ){

                        strPcses->Insert(0,"2.13");

                        if(MessageDlg(
                        "eTe2.13Oɍꂽetet@Ĉ悤łB\n\nt@CVo[W̌`ɏ܂H",
                        mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)
                         == mrYes){
                                strPcses->SaveToFile(etename);
                        }
                } else {
                        MessageDlg(
                        "Ή̃o[Wetet@CA܂pltt@C܂łB",
                        mtInformation,TMsgDlgButtons() << mbOK, 0);

                        ErrorFlag = true;

                        SetDefault();
                        NewFile();
                        return;
                }
        }
        strPcses->Delete(0);
        //

        //Ⴄs[XZbg̃t@CH
        if(strPcses->Strings[0] != Plt.Name){
                PltLoadBody(strPcses->Strings[0]);
                if(ErrorFlag) return;

                PltChangedFlag = true;

        }

        NewPcs();
        PcsTotal = (strPcses->Count-1)>>1;

        ModifiedFlag = false;

}


//*.etet@C̏
void Tangram::eTeSave(AnsiString etename)
{
        if(ModifiedFlag){
                strPcses->Insert(0,"2.13");
                strPcses->SaveToFile(etename);
                strPcses->Delete(0);
                Filename = ExpandFileName(etename);

                ModifiedFlag = false;
        }

}


//G[
void Tangram::pltNotFound()
{
        ErrorFlag = true;
        MessageDlg(
                "`\n\n.pltt@Cւ񂩂̂A\n\nEĂȁB",
                mtInformation,TMsgDlgButtons() << mbOK, 0);

}


void Tangram::eteNotFound()
{
        ErrorFlag = true;
        MessageDlg(
                "w肳ꂽt@C܂łB",
                mtInformation,TMsgDlgButtons() << mbOK, 0);

}








//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yOtBbNXz

//Fݒ
void Tangram::CSet(TColor bgcolor, int h1,int s1,int v1, int h2,int s2,int v2)
{
        int i,c;
        unsigned char r,g,b;

        //wiF̐ݒ
        BGColor = bgcolor;

        //s[X̐F̐ݒ
        for(i=0; i<maxplates; i++){
                HSVtoRGB((h1+random(h2)) & 0xff,s1+random(s2),v1+random(v2), r,g,b);
                c = r;
                c += g<<8;
                c += b<<16;
                PltColor[i] = (TColor)c;
        }

}


//Pcss[X`
//ʏTCY
void Tangram::GetBmp(int index, double ratio, Graphics::TBitmap* buf, bool tr)
{
        int i,j;
        TPcs Pcs__;

        TRect Rect;
        Rect.Top = 0;
        Rect.Left = 0;
        Rect.Bottom = buf->Height;
        Rect.Right = buf->Width;

        buf->Canvas->Brush->Color = BGColor;
        buf->Canvas->Brush->Style = bsSolid;
        if(!(tr)) buf->Canvas->FillRect(Rect);

        if(index != -1){
                Pcs__ = Pcs;
                PcsSelect(index);
        }

        if((double)ZoomPercentage*ratio>100.)
                buf->Canvas->Pen->Width = 2;
        else    buf->Canvas->Pen->Width = 1;

        for(i=0; i<Plt.Plates; i++){
                buf->Canvas->Pen->Color = PltColor[prior[i]];
                buf->Canvas->Brush->Color = PltColor[prior[i]];

                if((prior[i] == PltActive) || (PltActive == plAll && active[prior[i]])){
                        buf->Canvas->Brush->Style = bsClear;
                } else {
                        buf->Canvas->Brush->Style = bsSolid;
                }

                PopBank(prior[i],ratio);
                for(j=0; j<Plt.Edges[prior[i]]; j++)
                        PltPoint[j] = Point(
                                        (int)( 256.0*ratio
                                        + ((double)PltPoint[j].x-256.0*ratio)
                                                *(double)ZoomPercentage/100.0 ),
                                        (int)( 256.0*ratio
                                        + ((double)PltPoint[j].y-256.0*ratio)
                                                *(double)ZoomPercentage/100.0 )
                                );

                buf->Canvas->Polygon(PltPoint, Plt.Edges[prior[i]]-1);
        }

        if(index != -1) PushPcs(Pcs__);

}
//Xgb`Rs[
void Tangram::GetStrechedBmp(int index, Graphics::TBitmap* bufbuf, Graphics::TBitmap* buf, bool tr, bool aa)
{
                int c[3][128][128];
                int m,n,i,j;
                Byte *ptr;

        TRect Rect;
        Rect.Top = 0;
        Rect.Left = 0;
        Rect.Bottom = 512;
        Rect.Right = 512;

        if(tr) bufbuf->Canvas->StretchDraw( Rect,buf );

        GetBmp(index,1.,bufbuf,tr);

        if(aa && (buf->Height == 128) && (buf->Width == 128)){
        //A`GCAX
                for( m=0; m<128; m++ ){
                        for( n=0; n<128; n++){
                                for( i=0; i<3; i++) c[i][n][m] = 0;
                        }
                }
                for( m=0; m<512; m++ ){
                        ptr = (Byte *)bufbuf->ScanLine[m];
                        for( n=0; n<512; n++){
                                c[0][n>>2][m>>2] += *ptr++;
                                c[1][n>>2][m>>2] += *ptr++;
                                c[2][n>>2][m>>2] += *ptr++;
                        }
                }
                for( m=0; m<128; m++ ){
                        ptr = (Byte *)buf->ScanLine[m];
                        for( n=0; n<128; n++){
                                *ptr++ = gtbl[c[0][n][m]>>4];
                                *ptr++ = gtbl[c[1][n][m]>>4];
                                *ptr++ = gtbl[c[2][n][m]>>4];
                        }
                }
        } else {
                Rect.Top = 0;
                Rect.Left = 0;
                Rect.Bottom = buf->Height;
                Rect.Right = buf->Width;
                buf->Canvas->StretchDraw( Rect,bufbuf );
        }

}








//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ y̑z

//摜̍ŏ`߂
TRect Tangram::GetMinimumRect(double ratio)
{

        int i,j;
        TRect rect = Rect( 127,127, 0,0 );

        for(i=0; i<Plt.Plates; i++){
                PopBank(i,ratio);
                for(j=0; j<Plt.Edges[i]; j++)
                        PltPoint[j] = Point(
                                        (int)( 256.0*ratio
                                        + ((double)PltPoint[j].x-256.0*ratio)
                                                *(double)ZoomPercentage/100.0 ),
                                        (int)( 256.0*ratio
                                        + ((double)PltPoint[j].y-256.0*ratio)
                                                *(double)ZoomPercentage/100.0 )
                                );
                for(j=0; j<Plt.Edges[i]; j++){
                        if(PltPoint[j].x<rect.Left) rect.Left = PltPoint[j].x;
                        if(PltPoint[j].x>rect.Right) rect.Right = PltPoint[j].x;
                        if(PltPoint[j].y<rect.Top) rect.Top = PltPoint[j].y;
                        if(PltPoint[j].y>rect.Bottom) rect.Bottom = PltPoint[j].y;
                }
        }

        return rect;

}

//---------------------------------------------------------------------------

