/*
	Tangram class 0.01
		for Borland C++ Builder 5
		Copyright aX,2003

*/
#ifndef TangramH
#define TangramH


//s[Xƃs[X̕ӂ̐̐(eTe2)
#define maxplates 32
#define maxedges  64

//PltActivep
#define plAll  -2
#define plNone -1


//s[X`f[^jbg
struct TPlt{
        AnsiString Name;
        int  Plates;
        int  Edges[maxplates];
        int  centerX[maxplates];
        int  centerY[maxplates];
        int  X[maxplates][maxedges];
        int  Y[maxplates][maxedges];
        int  unitDeg;
        AnsiString Caption;
};

//`f[^jbg
struct TPcs{
        AnsiString Caption;
        int     X[maxplates];
        int     Y[maxplates];
        int     dDeg[maxplates];
        double  Flip[maxplates];
};

 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ yNX錾z
class Tangram
{
private:
        void    strPltesExpand(TStringList* strPltes);
        void    sToPcs(void);
        void    sTod(void);
        void    PcsTos(void);
        void    RefleshBank(void);
        void    PushBank(int pltnum);
        void    PopBank(int pltnum, double ratio);
        void    CalcPoint(int pltnum);
        int     Cutw(int w);
        TPoint  roll(int u,int v,int w);
        void    PltLoadBody(AnsiString pltname);
        void    pltNotFound(void);
        void    eteNotFound(void);
        bool    WithinRect(TRect rect, TPoint point);

        int     d[1024];
        AnsiString s;

        int     ctbl[720];
        int     gtbl[256];

        TPcs    PcsOr;
        TPcs    Pcs_;

public:
	Tangram(void);  //RXgN^
        ~Tangram(void); //fXgN^

        void    SetDefault(void);
        void    CSet(TColor bgcolor, int h1,int s1,int v1, int h2,int s2,int v2);
        void    NewPcs(void);
        void    NewFile(void);
        void    PushPcs(TPcs &srcPcs);
        void    PopPcs(TPcs &dstPcs);
        void    PcsSelect(int index);
        void    PltSelect(TPoint pos, Graphics::TBitmap* buf, bool realselect);
        void    PltSelectRect(TRect rect);
        void    PltSleep(void);
        void    PltMove(int x, int y);
        TPoint  GetAllRotAxis(void);
        void    AllRotRefresh(void);
        void    PltRotate(int ddDeg);
        void    PltRotAdjust(void);
        void    PltFlip(void);
        void    ListAdd(int index);
        void    ListDelete(int index);
        void    ListExchange(int index1, int index2);
        void    PltLoad(AnsiString pltname);
        void    eTeLoad(AnsiString etename);
        void    eTeSave(AnsiString etename);
        void    PushPcsCaption(int index, AnsiString PcsCaption);
        AnsiString PopPcsCaption(int index);
        AnsiString Filename;
        void    GetBmp(int index, double ratio, Graphics::TBitmap* buf, bool tr);
        void    GetStrechedBmp(int index, Graphics::TBitmap* bufbuf, Graphics::TBitmap* buf, bool tr, bool aa);
        void    mkGammaTable(double g);
        TRect   GetMinimumRect(double ratio);

        TStringList* strPcses;          //
        TStringList* strPltes;          //

        TPlt    Plt;
        TPcs    Pcs;

        int     PcsTotal;

        double  gamma;
        TColor  BGColor;
        TColor  PltColor[maxplates];

        int     prior[maxplates];
        bool    active[maxplates];

        int     PltActive;
        int     AllRotdDeg;
        TPoint  AllRotAxis;
        bool    AllRotFlag;

        TPoint  PltPoint[maxedges];
        TPoint  PltPointBank[maxplates][maxedges];
        int     ZoomPercentage;

        bool    ModifiedFlag;
        bool    PltChangedFlag;
        bool    ErrorFlag;

};

#endif
